<template>
  <transition name="toggle-height">
    <div
      v-if="viewCard"
      class="registration-form__card"
    >
      <img
        class="close"
        :src="require('@/static/img/close_small.svg')"
        @click="$emit('on-clear')"
      >
      <div
        class="registration-form__card-content"
        :class="showeMoreButton && '--fade'"
      >
        <div ref="card-content">
          <div class="registration-form__card-title">
            {{ card.name }}
          </div>
          <span class="registration-form__card-text">
            ИНН: {{ inn }}
          </span>
          <span class="registration-form__card-text">
            КПП: {{ card.kpp || '—' }}
          </span>
          <div class="registration-form__card-text">
            ОГРН: {{ card.ogrnValue }} - {{ card.ogrnDate }}
          </div>
          <div class="registration-form__card-text">
            {{ card.legalAddress }}
          </div>
          <div class="activities-wrap">
            <div
              v-for="(activity, index) in parseActivity(card.activity || [])"
              :key="index"
              class="registration-form__card-text"
            >
              {{ activity.code }} {{ activity.text }}
            </div>
          </div>
        </div>
      </div>
      <div
        v-if="showeMoreButton"
        class="more-button"
        @click="onClickMoreButton"
      >
        Показать все
      </div>
      <ObModal
        ref="modal"
        size="large"
        title="Направления деятельности"
        :is-show-controls="true"
        :is-read-only="true"
      >
        <div
          v-for="(activity, index) in parseActivity(card.activity || [])"
          :key="index"
          class="activity-modal"
        >
          {{ activity.code }} {{ activity.text }}
        </div>
      </ObModal>
    </div>
  </transition>
</template>

<script>
import ObModal from 'common-components/src/obComponents/obModal'

const MAX_HEIGHT = 160

export default {
  name: 'CardInfo',
  components: {
    ObModal
  },
  props: {
    card: {
      type: Object,
      default: () => {}
    },
    inn: {
      type: String,
      default: ''
    }
  },
  data () {
    return {
      showAllActivities: undefined
    }
  },
  computed: {
    viewCard () {
      return this.card && Object.keys(this.card).length
    },
    showeMoreButton () {
      return this.showAllActivities !== undefined && !this.showAllActivities
    }
  },
  watch: {
    card () {
      this.$nextTick(() => {
        let height = (this.$refs['card-content'] && this.$refs['card-content'].offsetHeight) || 0
        this.showAllActivities = height <= MAX_HEIGHT
      })
    }
  },
  methods: {
    parseActivity (data) {
      return typeof data === 'object' ? data : JSON.parse(data)
    },
    onClickMoreButton () {
      this.$refs.modal.open()
    }
  }
}
</script>

<style lang="scss" scoped>
    @import "~common-components/src/assets/style/ob-style";

    .registration-form {
        &__card {
            margin-top: 20px;
            border: 1px solid $lavender;
            border-radius: 3px;
            padding: 9px 23px 13px 11px;
            position: relative;
            &-content {
                position: relative;
                max-height: 160px;
                overflow: hidden;
                &::after {
                    content: '';
                    display: block;
                    position: absolute;
                    bottom: 0;
                    left: 0;
                    width: 100%;
                    height: 25px;
                    background: linear-gradient(to top, rgba(255, 255, 255, 1) 0%, rgba(255, 255, 255, 0) 100%);
                    opacity: 0;
                }
                &.--fade {
                    &::after {
                        opacity: 1;
                    }
                }
            }
            &-title {
                margin-bottom: 3px;
                @include font-mixin(12px, 17px, 600, $shale-gray, 0.2px);
            }
            &-text {
                @include font-mixin(12px, 17px, 400, $gray-slate, 0.2px);
            }
            .close {
                position: absolute;
                top: 12px;
                right: 12px;
                cursor: pointer;
            }
        }
    }

    .more-button {
        margin-top: 2px;
        font-size: 12px;
        line-height: 17px;
        color: #004BC8;
        cursor: pointer;
    }

    .activity-modal {
        @include font-mixin(14px, 18px, 400, $color-text-base, 0.4px);
        & + .activity-modal {
            margin-top: 10px;
        }
    }
</style>
